<?php

// config

define("GMRID", "!!!");
define("SECRET", "!!!");

// validate input

$persId = strval($_POST["persId"]);
$token = strval($_POST["token"]);

if (empty($persId) || empty($token)) {
	die("wrong params");
}

$ip = trim(isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR']);

// auth

$params = array();
$params["uid"] = $persId;
$params["hash"] = $token;
$params["ip"] = $ip;

$signparams = $params;
$signparams["appid"] = GMRID;
ksort($signparams);

$str = http_build_query($signparams, '', '');

$str .= SECRET;

$sign = md5($str);
$params["sign"] = $sign;

$url = "https://games.mail.ru/app/" . GMRID . "/gas?" . http_build_query($params);

$contextOptions = array(
	"http" => array(
		"method" => "GET",
		"user_agent" => "GCTestAuth"
	)
);

if (defined("HTTP_CONTEXT_PROXY")) {
	$contextOptions["http"]["proxy"] = HTTP_CONTEXT_PROXY;
}

$context = stream_context_create($contextOptions);

$response = file_get_contents($url, false, $context);

if (empty($response)) {
	die("server error");
}

$json = json_decode($response, true);
if (!is_array($json)) {
	die("server error");
}


if ($json["status"] == "ok") {
	echo "OK";
} else if ($json["status"] == "error") {
	echo "Error: code=" . $json["errcode"] . " message=" . $json["errmsg"];
} else {
	echo "Unknown error";
}

